#include <windows.h>
#include <stdio.h>

typedef void (__stdcall *PFN_YPassDecrypt)(char *inUserName, char *inEOption, char *oPwd);

void
TestYPass(
	char *userId,
	char *eOptions)
{
	char password[256]	= {0};

	HMODULE hYPass = LoadLibrary("y!pass.dll");

	if (hYPass)
	{
		PFN_YPassDecrypt pYPassDecrypt = 
							(PFN_YPassDecrypt)GetProcAddress(
															hYPass,
															"ypassDecrypt");

		if (pYPassDecrypt)
		{
			pYPassDecrypt(userId, eOptions, password);
			printf("Saved Yahoo User Id: %s\n", userId);
			printf("Saved Yahoo password: %s\n", password);
		}
		else
		{
			printf("Error: ypassDecrypt not found in Y!Pass.dll export table.\n");
		}

		FreeLibrary(hYPass);
	}
	else
	{
		printf("Error: Failed to load Y!Pass.dll\n");
	}

	return;
}

int
main()
{
	int			nReturnValue				= 0;
	HKEY		hYahooKey					= NULL;
	DWORD		tempSize					= 0;
	char		userId[MAX_PATH];
	char		eOptions[MAX_PATH * 2];

	nReturnValue = RegOpenKeyA(
							HKEY_CURRENT_USER,
							"Software\\Yahoo\\Pager",
							&hYahooKey);

	if (nReturnValue != ERROR_SUCCESS)
	{
		printf("Error: Failed to open yahoo registry key\n");
		goto funcExit;
	}

	tempSize = sizeof(userId) - 1;
	userId[tempSize] = 0;
	nReturnValue = RegQueryValueExA(
							hYahooKey,
							"Yahoo! User ID",
							NULL,
							NULL,
							(LPBYTE)userId,
							&tempSize);

	if (nReturnValue != ERROR_SUCCESS || tempSize <= 0)
	{
		printf("Error: No saved yahoo user id\n");
		goto funcExit;
	}

	tempSize = sizeof(eOptions) - 1;
	eOptions[tempSize] = 0;
	nReturnValue = RegQueryValueExA(
							hYahooKey,
							"EOptions String",
							NULL,
							NULL,
							(LPBYTE)eOptions,
							&tempSize);

	if (nReturnValue != ERROR_SUCCESS || tempSize <= 0)
	{
		printf("Error: No saved yahoo password\n");
		goto funcExit;
	}

	TestYPass(userId, eOptions);

funcExit:

	if (hYahooKey)
	{
		RegCloseKey(hYahooKey);
	}

	return;
}